function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var path = _interopDefault(require('path'));
var loaderUtils = _interopDefault(require('loader-utils'));
var slash = _interopDefault(require('slash'));

/**
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
var comlinkLoaderSpecificOptions = ['multiple', 'multi', 'singleton'];
function loader() {}

loader.pitch = function (request) {
  var options = loaderUtils.getOptions(this) || {};
  var multi = options.multiple || options.multi || options.singleton === false;
  var workerLoaderOptions = {};

  for (var i in options) {
    if (comlinkLoaderSpecificOptions.indexOf(i) === -1) {
      workerLoaderOptions[i] = options[i];
    }
  }

  return ("\n    import {Comlink} from 'comlinkjs';\n    " + (multi ? '' : 'var inst;') + "\n    export default function f() {\n      " + (multi ? 'var inst =' : 'inst = inst ||') + " Comlink.proxy(require('!worker-loader?" + (JSON.stringify(workerLoaderOptions)) + "!" + (slash(path.resolve(__dirname, 'comlink-worker-loader.js'))) + "!" + request + "')());\n      return this instanceof f ? new inst : inst;\n    }\n  ").replace(/\n\s*/g, '');
};

module.exports = loader;
//# sourceMappingURL=comlink-loader.js.map
